
#include <avr/io.h>
#include <avr/interrupt.h>
#include <setjmp.h>
#include "uart.h"
#include "sig455.h"

/* C prototype
 * output on port B, bits 6-0 (7 not avaialble on arduino)
 */
void
gen_am(unsigned long dphase)
{
	unsigned long phase;
	unsigned char *p;

amrun1:
	p = sw50;
amrun2:
	PORTB = *(p + ((phase >> 24) & 255));
	phase += dphase;
	if ((SREG & 0x40) != 0x40)
		goto amrun2;

	p = sw10;
amrun3:
	PORTB = *(p + ((phase >> 24) & 255));
	phase += dphase;
	if ((SREG & 0x40) == 0x40)
		goto amrun3;
	goto amrun1;
}

void
gen_fm(unsigned long dphase1, unsigned long dphase2)
{
	unsigned long phase;
	unsigned char *p;

	p = sw50;
fmrun1:
	PORTB = *(p + ((phase >> 24) & 255));
	phase += dphase1;
	if ((SREG & 0x40) != 0x40)
		goto fmrun1;
fmrun2:
	PORTB = *(p + ((phase >> 24) & 255));
	phase += dphase2;
	if ((SREG & 0x40) == 0x40)
		goto fmrun2;
	goto fmrun1;
}

